DECLARE FUNCTION GetLine$ ()
'  Name:       ChineseKwicOneString
'  Type:       Program
'  Module:     CKWIC1IN.BAS

'  Makes KWIC concordance with index from selected text for one Chinese
'  string input from keyboard. Even.odd check prevents breaking characters
'  on the wrong byte.

'  .MAK file:  CKWIC1IN.BAS
'              PARSE.BAS

DECLARE SUB ParseWord (a$, sep$, word$)

'  Initialization
   CLS
   PRINT
   PRINT "CKWIC1IN "; COMMAND$
   PRINT

   LET word$ = " "
'  Get input and output filenames from the command line
   cmd$ = COMMAND$
   ParseWord cmd$, " ,", inFile$
   ParseWord cmd$, " ,", outFile$
   ParseWord cmd$, " ,", hexword$

'  Verify that both filenames were given
   IF outFile$ = "" THEN
      PRINT
      PRINT "Usage: CKWIC1 inFileName.ext outFileName.ext NeiMa"
      PRINT "Will ask for input if no NeiMa specified"
      SYSTEM
   END IF


   OPEN inFile$ FOR INPUT AS #1
   IF LOF(1) = 0 THEN
      CLOSE #1
      KILL inFile$
      PRINT
      PRINT "File not found - "; inFile$
      SYSTEM
   END IF
  
   OPEN outFile$ FOR APPEND AS #2  'holds unsorted kwic text
   IF hexword$ = "" THEN
      INPUT "What character do you want to find"; word$
   ELSE
      hex1$ = "&H" + LEFT$(hexword$, 2)
      hex2$ = "&H" + RIGHT$(hexword$, 2)
      hex1 = VAL(hex1$)
      hex2 = VAL(hex2$)
      word$ = CHR$(hex1) + CHR$(hex2)
   END IF
   PRINT "Processing... patience"

start:
   DO UNTIL EOF(1)
      LINE INPUT #1, text$
      text$ = SPACE$(36) + text$ + SPACE$(36)  '36 blanks
      keyword = 37
      beginline = 1
      indexcode = 0
 
      DO
         indexcode = INSTR(keyword, text$, "a")             'check for index
         IF indexcode = 37 THEN
            index$ = MID$(text$, (indexcode + 2), 4)        'store index no.
         END IF
         keyword = INSTR(keyword, text$, word$)
         IF keyword = 0 THEN GOTO start
         beginline = (keyword - 36)
         keyword = keyword + 2
         even.odd$ = STR$(keyword / 2)                      'divide by two
         IF VAL(RIGHT$(even.odd$, 2)) <> .5 THEN GOTO 10 'skip even byte
         IF index$ = "" THEN
            PRINT #2, MID$(text$, beginline, 80)
         ELSE
            PRINT #2, MID$(text$, beginline, 76); index$
         END IF
10    LOOP WHILE beginline < LEN(text$)
   LOOP
   CLOSE
   END

   FUNCTION GetLine$
      DO UNTIL LOF(1) = 0
         LINE INPUT #1, text$
         GetLine$ = GetLine$ + text$
      LOOP
   END FUNCTION

